import { ParsedCron, ParsedRate } from './parse';
import { DateInput } from './types';
/**
 * generate the next occurrence which ends after or at the same time as the "from" date value,
 * includes occurences that start before the "from" date, but end after
 * NOTE: does not deal with durations, only start
 * returns NULL when there is no more future occurrence
 * @param {*} parsed the value returned by "parse" function of this module
 * @param {*} from the Date to start from
 */
interface NextCronOptions {
    inclusive?: boolean;
    tz?: 'local' | 'utc';
}
export declare function nextCron(parsed: ParsedCron, from: Date, duration: number, options?: NextCronOptions): Date | null;
export declare function nextRate(rate: ParsedRate, from: DateInput | null, inclusive?: boolean): Date | null;
export {};
