import { DateInput } from "./types";
export declare type ParsedRule = (string | number)[];
export interface ParsedCron {
    minutes: ParsedRule;
    hours: ParsedRule;
    daysOfMonth: ParsedRule;
    months: ParsedRule;
    daysOfWeek: ParsedRule;
    years: ParsedRule;
    duration: number;
    start: Date;
    end: Date | null;
    tz?: 'utc' | 'local';
}
export interface ParsedRate {
    rate: number;
    duration: number;
    value: number;
    unit: string;
    start: Date;
    end: Date | null;
}
export declare function validateParsedRule(rule: ParsedRule): void;
export declare function parse(cron: string, start?: DateInput, end?: DateInput, isRateExpression?: boolean): ParsedCron | ParsedRate;
export declare function parseRateExpression(expression: string, start?: DateInput, end?: DateInput): ParsedRate;
export declare function parseCron(cron: string, start?: DateInput, end?: DateInput): ParsedCron;
